PStringArray Class Reference

This is an array collection class of `PString` objects. More...

`#include <pstring.h>`

Inheritance diagram for PStringArray:

## Public Member Functions

Overrides from class PObject
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...
New functions for class
PINDEX | GetStringsIndex (const PString &str) const
| As for `GetValuesIndex()` but takes a PString argument so that literals will be automatically converted. More...
PString | operator[] (PINDEX index) const
PString & | operator[] (PINDEX index)
| Retrieve a reference to the object in the array. More...
PINDEX | AppendString (const PString &str)
| Append a string to the array. More...
PStringArray & | operator+= (const PStringArray &array)
| Concatenate a PString or PStringArray to the array. More...
PStringArray & | operator+= (const PString &str)
PStringArray | operator+ (const PStringArray &array)
| Create a new PStringArray, and add PString or PStringArray to it a new PStringArray. More...
PStringArray | operator+ (const PString &str)
char ** | ToCharArray (PCharArray *storage=NULL) const
| Create an array of C strings. More...
Public Member Functions inherited from PArray< T >
| PArray (PINDEX initialSize=0)
| Create a new array of objects. More...
virtual PObject * | Clone () const
| Make a complete duplicate of the array. More...
T & | operator[] (PINDEX index) const
| Retrieve a reference to the object in the array. More...
Public Member Functions inherited from PArrayObjects
PINLINE | PArrayObjects (PINDEX initialSize=0)
| Create a new array of objects. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two arrays. More...
virtual PINDEX | GetSize () const
| Get size of array. More...
virtual PBoolean | SetSize (PINDEX newSize)
| Set the size of the array in objects. More...
virtual PINDEX | Append (PObject *obj)
| Append a new object to the collection. More...
virtual PINDEX | Insert (const PObject &before, PObject *obj)
| Insert a new object immediately before the specified object. More...
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Insert a new object at the specified ordinal index. More...
virtual PBoolean | Remove (const PObject *obj)
| Remove the object from the collection. More...
virtual PObject * | RemoveAt (PINDEX index)
| Remove the object at the specified ordinal index from the collection. More...
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| Set the object at the specified ordinal position to the new value. More...
virtual PObject * | GetAt (PINDEX index) const
| Get the object at the specified ordinal position. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | PrintOn (ostream &strm) const
| Print the collection on the stream. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...

## Construction

| PStringArray (PINDEX count, char const *const *strarr, PBoolean caseless=false)
| Create a PStringArray from the array of C strings. More...
| PStringArray (const PString &str)
| Create a PStringArray of length one from the single string. More...
| PStringArray (const PStringList &list)
| Create a PStringArray from the list of strings. More...
| PStringArray (const PSortedStringList &list)
| Create a PStringArray from the sorted list strings. More...
| PStringArray (const std::vector< PString > &vec)
| Create a PStringArray from a vector of PStrings. More...
| PStringArray (const std::vector< std::string > &vec)
| Create a PStringArray from a vector of std::string. More...
template<typename stlContainer >
static PStringArray | container (const stlContainer &vec)
| Create a PStringArray from an STL container. More...

## Additional Inherited Members

Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Member Functions inherited from PArray< T >
| PArray (int dummy, const PArray *c)
Protected Member Functions inherited from PCollection
PINLINE | PCollection (int dummy, const PCollection *coll)
| Constructor used in support of the Clone() function. More...
Protected Member Functions inherited from PContainer
| PContainer (int dummy, const PContainer *cont)
| Constructor used in support of the Clone() function. More...
| PContainer (PContainerReference &reference)
| Construct using static PContainerReference. More...
virtual void | DestroyContents ()=0
| Destroy the container contents. More...
virtual void | AssignContents (const PContainer &c)
| Copy the container contents. More...
void | CopyContents (const PContainer &c)
| Copy the container contents. More...
void | CloneContents (const PContainer *src)
| Create a duplicate of the container contents. More...
void | Destruct ()
| Internal function called from container destructors. More...
virtual void | DestroyReference ()
| Destroy the PContainerReference instance. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...
Protected Attributes inherited from PArrayObjects
PBaseArray< PObject * > * | theArray
Protected Attributes inherited from PContainer
PContainerReference * | reference

## Detailed Description

This is an array collection class of `PString` objects.

It has all the usual functions for a collection, with the object types set to `PString` pointers.

In addition some addition functions are added that take a const `PString` reference instead of a pointer as most standard collection functions do. This is more convenient for when string expressions are used as parameters to function in the collection.

See the `PAbstractArray` and `PArray` classes and `PDECLARE_ARRAY` macro for more information.

## Constructor & Destructor Documentation

PStringArray::PStringArray | ( | PINDEX | count,
|  | char const *const * | strarr,
|  | PBoolean | caseless = `false`
| ) |  |

Create a PStringArray from the array of C strings.

If count is P_MAX_INDEX then strarr is assumed to point to an array of strings where the last pointer is NULL.

Parameters

  count | Count of strings in array
  strarr | Array of C strings
  caseless | New strings are to be PCaselessStrings

PStringArray::PStringArray | ( | const PString & | str | ) |

Create a PStringArray of length one from the single string.

Parameters

  str | Single string to convert to an array of one.

PStringArray::PStringArray | ( | const PStringList & | list | ) |

Create a PStringArray from the list of strings.

Parameters

  list | List of strings to convert to array.

PStringArray::PStringArray | ( | const PSortedStringList & | list | ) |

Create a PStringArray from the sorted list strings.

Parameters

  list | List of strings to convert to array.

PStringArray::PStringArray | ( | const std::vector< PString > & | vec | ) |

inline

Create a PStringArray from a vector of PStrings.

References AppendString().

PStringArray::PStringArray | ( | const std::vector< std::string > & | vec | ) |

inline

Create a PStringArray from a vector of std::string.

References AppendString().

## Member Function Documentation

PINDEX PStringArray::AppendString | ( | const PString & | str | ) |

Append a string to the array.

Parameters

  str | String to append.

Referenced by container(), and PStringArray().

template<typename stlContainer >

static PStringArray PStringArray::container | ( | const stlContainer & | vec | ) |

inline static

Create a PStringArray from an STL container.

References AppendString().

PINDEX PStringArray::GetStringsIndex | ( | const PString & | str | ) | const

As for `GetValuesIndex()` but takes a PString argument so that literals will be automatically converted.

Returns
  Index of string in array or P_MAX_INDEX if not found.

Parameters

  str | String to search for index of

PStringArray PStringArray::operator+ | ( | const PStringArray & | array | ) |

Create a new PStringArray, and add PString or PStringArray to it a new PStringArray.

Returns
  A new PStringArray with the additional elements(s)

PStringArray PStringArray::operator+ | ( | const PString & | str | ) |

PStringArray& PStringArray::operator+= | ( | const PStringArray & | array | ) |

Concatenate a PString or PStringArray to the array.

Returns
  The PStringArray with the new items appended

PStringArray& PStringArray::operator+= | ( | const PString & | str | ) |

PString PStringArray::operator[] | ( | PINDEX | index | ) | const

Parameters

  index | Index position in the collection of the object.

PString& PStringArray::operator[] | ( | PINDEX | index | ) |

Retrieve a reference to the object in the array.

If there was not an object at that ordinal position or the index was beyond the size of the array then the function will create a new one.

Returns
  reference to the object at `index` position.

Parameters

  index | Index position in the collection of the object.

virtual void PStringArray::ReadFrom | ( | istream & | strm | ) |

virtual

Input the contents of the object from the stream.

This is primarily used by the standard `operator>>` function.

The default behaviour reads '\n' separated strings until `!strm.good()`.

Reimplemented from PObject.

char** PStringArray::ToCharArray | ( | PCharArray * | storage = `NULL` | ) | const

Create an array of C strings.

If storage is NULL then this returns a single pointer that must be disposed of using free(). Note that each of the strings are part of the same memory allocation so only one free() is required.

If storage is not null then that is used to allocate the memory.

The documentation for this class was generated from the following file:

- pstring.h